diff --git a/drivers/hwtracing/coresight/coresight-syscfg.c b/drivers/hwtracing/coresight/coresight-syscfg.c
index 11138a9762b0..b7e9fb822e8f 100644
--- a/drivers/hwtracing/coresight/coresight-syscfg.c
+++ b/drivers/hwtracing/coresight/coresight-syscfg.c
@@ -65,7 +65,6 @@ static int cscfg_add_csdev_cfg(struct coresight_device *csdev,
 {
 	struct cscfg_config_csdev *config_csdev = NULL;
 	struct cscfg_feature_csdev *feat_csdev;
-	unsigned long flags;
 	int i;
 
 	/* look at each required feature and see if it matches any feature on the device */
@@ -89,9 +88,9 @@ static int cscfg_add_csdev_cfg(struct coresight_device *csdev,
 	}
 	/* if matched features, add config to device.*/
 	if (config_csdev) {
-		spin_lock_irqsave(&csdev->cscfg_csdev_lock, flags);
-		list_add(&config_csdev->node, &csdev->config_csdev_list);
-		spin_unlock_irqrestore(&csdev->cscfg_csdev_lock, flags);
+		scoped_guard(raw_spinlock_irqsave, &csdev->cscfg_csdev_lock) {
+			list_add(&config_csdev->node, &csdev->config_csdev_list);
+		}
 	}
 
 	return 0;
@@ -177,7 +176,6 @@ static int cscfg_load_feat_csdev(struct coresight_device *csdev,
 				 struct cscfg_csdev_feat_ops *ops)
 {
 	struct cscfg_feature_csdev *feat_csdev;
-	unsigned long flags;
 	int err;
 
 	if (!ops->load_feat)
@@ -194,9 +192,9 @@ static int cscfg_load_feat_csdev(struct coresight_device *csdev,
 
 	/* add to internal csdev feature list & initialise using reset call */
 	cscfg_reset_feat(feat_csdev);
-	spin_lock_irqsave(&csdev->cscfg_csdev_lock, flags);
-	list_add(&feat_csdev->node, &csdev->feature_csdev_list);
-	spin_unlock_irqrestore(&csdev->cscfg_csdev_lock, flags);
+	scoped_guard(raw_spinlock_irqsave, &csdev->cscfg_csdev_lock) {
+		list_add(&feat_csdev->node, &csdev->feature_csdev_list);
+	}
 
 	return 0;
 }
@@ -765,7 +763,7 @@ static int cscfg_list_add_csdev(struct coresight_device *csdev,
 
 	INIT_LIST_HEAD(&csdev->feature_csdev_list);
 	INIT_LIST_HEAD(&csdev->config_csdev_list);
-	spin_lock_init(&csdev->cscfg_csdev_lock);
+	raw_spin_lock_init(&csdev->cscfg_csdev_lock);
 
 	return 0;
 }
@@ -853,17 +851,14 @@ EXPORT_SYMBOL_GPL(cscfg_unregister_csdev);
 void cscfg_csdev_reset_feats(struct coresight_device *csdev)
 {
 	struct cscfg_feature_csdev *feat_csdev;
-	unsigned long flags;
 
-	spin_lock_irqsave(&csdev->cscfg_csdev_lock, flags);
+	guard(raw_spinlock_irqsave)(&csdev->cscfg_csdev_lock);
+
 	if (list_empty(&csdev->feature_csdev_list))
-		goto unlock_exit;
+		return;
 
 	list_for_each_entry(feat_csdev, &csdev->feature_csdev_list, node)
 		cscfg_reset_feat(feat_csdev);
-
-unlock_exit:
-	spin_unlock_irqrestore(&csdev->cscfg_csdev_lock, flags);
 }
 EXPORT_SYMBOL_GPL(cscfg_csdev_reset_feats);
 
@@ -1048,7 +1043,6 @@ int cscfg_csdev_enable_active_config(struct coresight_device *csdev,
 {
 	struct cscfg_config_csdev *config_csdev_active = NULL, *config_csdev_item;
 	const struct cscfg_config_desc *config_desc;
-	unsigned long flags;
 	int err = 0;
 
 	/* quickly check global count */
@@ -1059,17 +1053,17 @@ int cscfg_csdev_enable_active_config(struct coresight_device *csdev,
 	 * Look for matching configuration - set the active configuration
 	 * context if found.
 	 */
-	spin_lock_irqsave(&csdev->cscfg_csdev_lock, flags);
-	list_for_each_entry(config_csdev_item, &csdev->config_csdev_list, node) {
-		config_desc = config_csdev_item->config_desc;
-		if ((atomic_read(&config_desc->active_cnt)) &&
-		    ((unsigned long)config_desc->event_ea->var == cfg_hash)) {
-			config_csdev_active = config_csdev_item;
-			csdev->active_cscfg_ctxt = (void *)config_csdev_active;
-			break;
+	scoped_guard(raw_spinlock_irqsave, &csdev->cscfg_csdev_lock) {
+		list_for_each_entry(config_csdev_item, &csdev->config_csdev_list, node) {
+			config_desc = config_csdev_item->config_desc;
+			if ((atomic_read(&config_desc->active_cnt)) &&
+			    ((unsigned long)config_desc->event_ea->var == cfg_hash)) {
+				config_csdev_active = config_csdev_item;
+				csdev->active_cscfg_ctxt = (void *)config_csdev_active;
+				break;
+			}
 		}
 	}
-	spin_unlock_irqrestore(&csdev->cscfg_csdev_lock, flags);
 
 	/*
 	 * If found, attempt to enable
@@ -1090,12 +1084,12 @@ int cscfg_csdev_enable_active_config(struct coresight_device *csdev,
 			 *
 			 * Set enabled if OK, err if not.
 			 */
-			spin_lock_irqsave(&csdev->cscfg_csdev_lock, flags);
-			if (csdev->active_cscfg_ctxt)
-				config_csdev_active->enabled = true;
-			else
-				err = -EBUSY;
-			spin_unlock_irqrestore(&csdev->cscfg_csdev_lock, flags);
+			scoped_guard(raw_spinlock_irqsave, &csdev->cscfg_csdev_lock) {
+				if (csdev->active_cscfg_ctxt)
+					config_csdev_active->enabled = true;
+				else
+					err = -EBUSY;
+			}
 		}
 	}
 	return err;
@@ -1117,23 +1111,22 @@ EXPORT_SYMBOL_GPL(cscfg_csdev_enable_active_config);
 void cscfg_csdev_disable_active_config(struct coresight_device *csdev)
 {
 	struct cscfg_config_csdev *config_csdev;
-	unsigned long flags;
 
 	/*
 	 * Check if we have an active config, and that it was successfully enabled.
 	 * If it was not enabled, we have no work to do, otherwise mark as disabled.
 	 * Clear the active config pointer.
 	 */
-	spin_lock_irqsave(&csdev->cscfg_csdev_lock, flags);
-	config_csdev = (struct cscfg_config_csdev *)csdev->active_cscfg_ctxt;
-	if (config_csdev) {
-		if (!config_csdev->enabled)
-			config_csdev = NULL;
-		else
-			config_csdev->enabled = false;
+	scoped_guard(raw_spinlock_irqsave, &csdev->cscfg_csdev_lock) {
+		config_csdev = (struct cscfg_config_csdev *)csdev->active_cscfg_ctxt;
+		if (config_csdev) {
+			if (!config_csdev->enabled)
+				config_csdev = NULL;
+			else
+				config_csdev->enabled = false;
+		}
+		csdev->active_cscfg_ctxt = NULL;
 	}
-	csdev->active_cscfg_ctxt = NULL;
-	spin_unlock_irqrestore(&csdev->cscfg_csdev_lock, flags);
 
 	/* true if there was an enabled active config */
 	if (config_csdev)
diff --git a/include/linux/coresight.h b/include/linux/coresight.h
index c13342594278..924b58c343b3 100644
--- a/include/linux/coresight.h
+++ b/include/linux/coresight.h
@@ -296,7 +296,7 @@ struct coresight_device {
 	/* system configuration and feature lists */
 	struct list_head feature_csdev_list;
 	struct list_head config_csdev_list;
-	spinlock_t cscfg_csdev_lock;
+	raw_spinlock_t cscfg_csdev_lock;
 	void *active_cscfg_ctxt;
 };
 